<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Original Author of file:
// Purpose of file:
// ----------------------------------------------------------------------------

/**
 * Envolution Install Script.
 *
 * This script will set the database up, and do the basic configurations of the script.
 * Once this script has run, please delete this file from your root directory.
 * There is a security risk if you keep this file around.
 *
 * The Envolution project is free software released under the GNU License.
 * Please read the credits file for more information on who has made this project possible.
----------------------------------------------------------
 * ChangeLog
 * 8/11/2002      Brian Lindner   Added PHPNuke 4.2 - 6.0 Upgrade scripts
 */

if (phpversion() >= "4.2.0") {
if ( ini_get('register_globals') != 1 ) {

$supers = array('_REQUEST',
				'_ENV', 
				'_SERVER', 
				'_POST', 
				'_GET', 
				'_COOKIE', 
				'_SESSION', 
				'_FILES', 
				'_GLOBALS' );
				
foreach( $supers as $__s) {
if ( is_array( $$__s ) == true ) extract( $$__s, EXTR_OVERWRITE );
}
unset($supers);
}
} else {

if ( ini_get('register_globals') != 1 ) {

$supers = array('HTTP_POST_VARS', 
				'HTTP_GET_VARS', 
				'HTTP_COOKIE_VARS', 
				'GLOBALS', 
				'HTTP_SESSION_VARS', 
				'HTTP_REQUEST_VARS', 
				'$HTTP_SERVER_VARS', 
				'$HTTP_ENV_VARS' );

foreach( $supers as $__s) {
if ( is_array( $$__s ) == true ) extract( $$__s, EXTR_OVERWRITE );
}
unset($supers);
}
}


set_time_limit(0);

// functions for the db abstraction layer
define('ADODB_DIR', 'pnadodb');
require_once ("pnadodb/adodb.inc.php");

ini_set('register_globals', 'On');
if (isset($alanguage)) {
        $currentlang = $alanguage;
}

if(!isset($prefix)) {
        include_once 'config/env-config.php';

        $prefix = $pnconfig['prefix'];
        $dbtype = $pnconfig['dbtype'];
        $dbhost = $pnconfig['dbhost'];
        $dbuname = $pnconfig['dbuname'];
        $dbpass = $pnconfig['dbpass'];
        $dbname = $pnconfig['dbname'];
        $system = $pnconfig['system'];
        $encoded = $pnconfig['encoded'];
}

// GRAB the upgrade version

if (!empty($encoded)) {
        // Decode username and password
        $dbuname = base64_decode($dbuname);
        $dbpass = base64_decode($dbpass);
}

$pnconfig['prefix'] = $prefix;

// database tables information
include_once 'pntables.php';

// functions for multilanguage support
include_once 'install/language.php';

installer_get_language();

// functions to modify config.php
include_once 'install/modify_config.php';

// functions for upgrades
include_once 'install/upgrade.php';

// functions for new installs
include_once 'install/newinstall.php';

// functions for rendering the gui
include_once 'install/gui.php';

// functions for accessing the db
include_once 'install/db.php';

// functions for various checks
include_once 'install/check.php';

// print the page header, include style sheets
print_header();

/*  This starts the switch statement that filters through the form options.
* the @ is in front of $op to suppress error messages if $op is unset and E_ALL
* is on */
switch(@$op) {

    case "CHM_check":
         print_CHM_check();
         break;

    case "Submit":
         print_submit();
         break;

    case "Change Info":
         print_change_info();
         break;

    case "New Install":
         print_new_install();
         break;

    case "Start":
         if(!isset($dbmake)) {
            $dbmake = false;
         }
         make_db($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, $dbmake);
         print_start();
         break;

    case "Continue":
         print_continue($upgrade);
         break;

    case "Set Login":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         input_data($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, $aid, $name, $pwd, $repeatpwd, $email, $url, $upgrade);
         update_config_php(true); // Scott - added
		 update_rte_config(true); // write rte-config.php - WindMeUp
         print_set_login($upgrade);
         break;

    case "Select Language":
         print_select_language();
         break;

    case "Set Language":
         $currentlang = $alanguage;
         print_default();
         break;

    case "Finish":
         print_finish();
         break;

    case "Finish Upgrade":
         print_finish_upgrade();
         break;

    case "Upgrade":
         print_upgrade();
         break;

    case "Check":
        do_check_php();
        do_check_chmod();
        break;
// Brian Lindner:  BEGIN UPGRADE AREA CALLS!!!
    case "Envolution 1.1.0":
         print_config_upgrade($op);
         break;
    case "Envolution 1.1.5":
         print_config_upgrade($op);
         break;
    case "envoUpgrade 1.1.0":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         update_config_php(true); // Scott - added
		 update_rte_config(true); // write rte-config.php - WindMeUp
		 update_sub_config(true); // write sub-config.php - WindMeUp
         do_upgrade_envolution($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '1.1.0');
         print_set_login_upgrade($op);
         break;
    case "envoUpgrade 1.1.5":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         update_config_php(true); // Scott - added
		 update_rte_config(true); // write rte-config.php - WindMeUp
		 update_sub_config(true); // write sub-config.php - WindMeUp
         do_upgrade_envolution($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '1.1.5');
         print_set_login_upgrade($op);
         break;
    case "PostNuke .714":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         update_config_php(true); // Scott - added
		 update_rte_config(true); // write rte-config.php - WindMeUp
		 update_sub_config(true); // write sub-config.php - WindMeUp
         do_upgrade_postnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '.714');
         //print_start($op);
         print_set_login_upgrade($op);
         break;
    case "PostNuke .721":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         update_config_php(true); // Scott - added
		 update_rte_config(true); // write rte-config.php - WindMeUp
		 update_sub_config(true); // write sub-config.php - WindMeUp
         do_upgrade_postnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '.72');
         //print_start($op);
         print_set_login_upgrade($op);
         break;
    case "PostNuke .723":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         update_config_php(true); // Scott - added
		 update_rte_config(true); // write rte-config.php - WindMeUp
		 update_sub_config(true); // write sub-config.php - WindMeUp
         do_upgrade_postnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '.72');
         //print_start($op);
         print_set_login_upgrade($op);
         break;
                case "PHPNuke 4.2":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '4.2');
         print_start($op);
         break;
           case "PHPNuke 4.3":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '4.3');
         print_start($op);
         break;
           case "PHPNuke 4.4":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '4.4');
         print_start($op);
         break;
                case "PHPNuke 5.0":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.0');
         print_start($op);
         break;
                case "PHPNuke 5.1":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.1');
         print_start($op);
         break;
                case "PHPNuke 5.2":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.2');
         print_start($op);
         break;
                case "PHPNuke 5.3":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.3');
         print_start($op);
         break;
                case "PHPNuke 5.31":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.31');
         print_start($op);
         break;
                case "PHPNuke 5.4":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.4');
         print_start($op);
         break;
                case "PHPNuke 5.5":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.5');
         print_start($op);
         break;
                case "PHPNuke 5.6":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '5.6');
         print_start($op);
         break;
                case "PHPNuke 6.0":
         $dbconn = dbconnect($dbhost, $dbuname, $dbpass, $dbname, $dbtype);
         do_upgrade_phpnuke($dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype, '6.0');
         print_start($op);
         break;



// END UPGRADE AREA CALLS


    default:
         print_select_language();
         break;
}

// print the footer, and closing tags
print_footer();


?>