<?php

// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//


/*

 * Smarty plugin

 * -------------------------------------------------------------

 * Type:     modifier

 * Name:     debug_print_var

 * Purpose:  formats variable contents for display in the console

 * -------------------------------------------------------------

 */

function smarty_modifier_debug_print_var($var, $depth = 0, $length = 40)

{

    if (is_array($var)) {

        $results = "<b>Array (".count($var).")</b>";

        foreach ($var as $curr_key => $curr_val) {

            $return = smarty_modifier_debug_print_var($curr_val, $depth+1);

            $results .= '<br>\r'.str_repeat('&nbsp;', $depth*2)."<b>$curr_key</b> =&gt; $return";

        }

        return $results;

    } else if (is_object($var)) {

        $object_vars = get_object_vars($var);

        $results = "<b>".get_class($var)." Object (".count($object_vars).")</b>";

        foreach ($object_vars as $curr_key => $curr_val) {

            $return = smarty_modifier_debug_print_var($curr_val, $depth+1);

            $results .= '<br>\r'.str_repeat('&nbsp;', $depth*2)."<b>$curr_key</b> =&gt; $return";

        }

        return $results;

    } else {

        if (empty($var) && $var != "0") {

            return '<i>empty</i>';

        }

        if (strlen($var) > $length ) {

            $results = substr($var, 0, $length-3).'...';

        } else {

            $results = $var;

        }

        $results = preg_replace("![\r\t\n]!", " ", $results);

        $results = htmlspecialchars(htmlspecialchars($results));

        return $results;

    }

}



/* vim: set expandtab: */



?>

