<?php

// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//


/*

 * Smarty plugin

 * -------------------------------------------------------------

 * Type:     modifier

 * Name:     truncate

 * Purpose:  Truncate a string to a certain length if necessary,

 *           optionally splitting in the middle of a word, and 

 *           appending the $etc string.

 * -------------------------------------------------------------

 */

function smarty_modifier_truncate($string, $length = 80, $etc = '...',

                                  $break_words = false)

{

    if ($length == 0)

        return '';



    if (strlen($string) > $length) {

        $length -= strlen($etc);

        $fragment = substr($string, 0, $length+1);

        if ($break_words)

            $fragment = substr($fragment, 0, -1);

        else

            $fragment = preg_replace('/\s+(\S+)?$/', '', $fragment);

        return $fragment.$etc;

    } else

        return $string;

}



/* vim: set expandtab: */



?>

