<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Semi-based on Sections but written from the ground up.
// ----------------------------------------------------------------------
// Filename: modules/Subjects/index.php
// Original Author: Jaroslaw Gilewski (http://www.yagi.com.pl)
// Modified and ported to eNvolution TiMax timax@envolution.com
// Purpose: displays the subjects on the site
// Modified by CybLeNoir - 01-03/01/2003
// ----------------------------------------------------------------------

if (!defined("LOADED_AS_MODULE")) {
         die ("You can't access this file directly...");
     }

include 'mainfile.php';

$ModName = basename( dirname( __FILE__ ) );

include("config/sub-config.php");
include("modules/$ModName/pntables.php");

modules_get_language();

//----------------------------------------------------------------------
//list subjects
function listsubjects()
{
    global $pntable, $ModName, $subjectsconfig, $bgcolor2;
    list($dbconn) = pnDBGetConn();
    $currentlang = pnUserGetLang();
    $sitename = pnConfigGetVar('sitename');

    if (!authorised(0, 'Subjects::Subject', '::', ACCESS_OVERVIEW)) {
        include("header.php");
        OpenTable();
        echo _SUBJECTSNOAUTH;
        CloseTable();
        include("footer.php");
        return;
    }

    include ('header.php');

    OpenTable();

    if (pnConfigGetVar('multilingual') == 1) {
        $column = &$pntable['subjects_column'];
        $querylang = "AND ($column[sublanguage]='$currentlang' OR $column[sublanguage]='')";
    } else
      $querylang = "";

    $column = &$pntable['subjects_column'];
    $column2 = &$pntable['subcategories_column'];
    $result = $dbconn->Execute("SELECT $column[subid], $column2[catid], $column2[catname],
                              $column2[cattext], $column[subname],
                                  $column[subtext], $column[subimage], $column[subcounter]
                              FROM $pntable[subjects]
                              LEFT JOIN $pntable[subcategories]
                              ON $column[catid]=$column2[catid]
                              WHERE $column[subactive] = 1 $querylang
                                                          ORDER BY $column2[catorder], $column[suborder]");

    echo "<table width=\"100%\" border=\"0\" align=\"center\" summary=\"layout\">";
                echo "<tr><td colspan=\"2\"><h1>" . _SUBJECTSLIST . "</h1></td></tr>";
    if (!$result->EOF) {
        $currcatid = 0;
        while(list($subid, $catid, $catname, $cattext, $subname, $subtext, $subimage, $subcounter) = $result->fields) {
            $now = date("Y-m-d H:i:00");
            $column = &$pntable['subpages_column'];
            $result2 = $dbconn->Execute("SELECT COUNT(*)
                                       FROM $pntable[subpages]
                                       WHERE $column[subid]=$subid AND $column[parentpageid]=0 AND
                                         $column[pagedatetime] < '$now'");
            list($pagesattached) = $result2->fields;
            $result2->Close();

            if($currcatid != $catid){
                echo "<tr><td colspan=\"2\" bgcolor=\"$bgcolor2\"><cnter><font class=\"pn-title\">$catname</font></center>$cattext</td></tr>";
                $currcatid = $catid;
            }
            if (authorised(0, 'Subjects::Subject', "$subname::$subid", ACCESS_READ)) {
                echo "<tr>";
                if($subimage != '')
                    echo "<td valign=\"top\"><a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid\"><img src=\"modules/$ModName/pages/$subimage\" border=\"0\" Alt=\"$subname\"></a></td>\n";
                else
                    echo "<td valign=\"top\"></td>\n";
                echo "  <td width=\"100%\" valign=\"top\">";
                echo "<h2><a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid\">$subname</a></h2>$subtext</td>\n"
                     ."</tr>\n";

            }
            $result->MoveNext();
        }
        } else
        echo "<tr><td align=\"center\">"._NOSUBJECTS."</td></tr>";
    echo "</table>";


    $result->Close();

    CloseTable();

    include ('footer.php');
}

//----------------------------------------------------------------------
//list pages
function listpages($subid, $orderby) {
    global $pntable, $ModName, $subjectsconfig, $datetime, $locale;
    list($dbconn) = pnDBGetConn();

    $column = &$pntable['subjects_column'];
    $result = $dbconn->Execute("SELECT $column[subname], $column[subtext], $column[subimage]
                              FROM $pntable[subjects]
                              WHERE $column[subid]=$subid");
    list($subname, $subtext, $subimage) = $result->fields;
    $result->Close();

    if (!authorised(0, 'Subjects::Subject', "$subname::$subid", ACCESS_READ)) {
        include ('header.php');
        OpenTable();
        echo _SUBJECTSPAGENOAUTH;
        CloseTable();
        include("footer.php");
        return;
    }

    include ('header.php');

    OpenTable();

    $column = &$pntable['subjects_column'];
    $result = $dbconn->Execute("UPDATE $pntable[subjects]
                                SET $column[subcounter]=$column[subcounter]+1
                                WHERE $column[subid]='$subid'");
    $result->Close();

    echo "<table width=\"100%\" border=\"0\" align=\"center\" summary=\"layout\">";
                echo "<tr><td colspan=\"2\"><h1>"._PAGESLIST." $subname</h1></td></tr>";
                echo "<tr>";
    if($subimage != '')
        echo "  <td colspan=\"2\" align=\"center\"><img src=\"modules/$ModName/pages/$subimage\" border=\"0\" Alt=\"$subname\"></td>\n";
    else
        echo "  <td colspan=\"2\"></td>\n";
    echo "</tr>\n"
         ."<tr>\n"
         ."  <td colspan=\"2\">$subtext</td>\n"
         ."</tr>\n"
         ."<tr>\n"
         ."  <td colspan=\"2\"><HR noshade size=\"1\"></td>\n"
         ."</tr>";
// I don't need sorting, so the following code has been disabled
// CybLeNoir
/*         ."<tr>\n"
         ."  <td colspan=\"2\">";

    echo "<center><font class=\"pn-normal\">"._SORTPAGESBY.": "
        .""._SORTPAGETITLE."&nbsp;(<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=titleA\">"._SORTASC."</a>/<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=titleD\">"._SORTDESC."</a>) "
        .""._SORTPAGEAUTHOR."&nbsp;(<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=authorA\">"._SORTASC."</a>/<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=authorD\">"._SORTDESC."</a>) "
        .""._SORTPAGEDATETIME."&nbsp;(<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=datetimeA\">"._SORTASC."</a>/<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=datetimeD\">"._SORTDESC."</a>) "
        .""._SORTPAGEPOPULARITY."&nbsp;(<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=hitsA\">"._SORTASC."</a>/<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=hitsD\">"._SORTDESC."</a>) "
        .""._SORTPAGEREVIEWS."&nbsp;(<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=reviewsA\">"._SORTASC."</a>/<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=reviewsD\">"._SORTDESC."</a>) "
        .""._SORTPAGESCORES."&nbsp;(<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=scoresA\">"._SORTASC."</a>/<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid&amp;orderby=scoresD\">"._SORTDESC."</a>)<BR>"
        .""._PAGESSORTEDBY.": ";
    if ($orderby == "titleA") echo ""._SORTPAGETITLE." ("._SORTASCENDING.")";
    elseif ($orderby == "authorA") echo ""._SORTPAGEAUTHOR." ("._SORTASCENDING.")";
    elseif ($orderby == "datetimeA") echo ""._SORTPAGEDATETIME." ("._SORTASCENDING.")";
    elseif ($orderby == "hitsA") echo ""._SORTPAGEPOPULARITY." ("._SORTASCENDING.")";
    elseif ($orderby == "reviewsA") echo ""._SORTPAGEREVIEWS." ("._SORTASCENDING.")";
    elseif ($orderby == "scoresA") echo ""._SORTPAGESCORES." ("._SORTASCENDING.")";
    elseif ($orderby == "titleD") echo ""._SORTPAGETITLE." ("._SORTDESCENDING.")";
    elseif ($orderby == "authorD") echo ""._SORTPAGEAUTHOR." ("._SORTDESCENDING.")";
    elseif ($orderby == "datetimeD") echo ""._SORTPAGEDATETIME." ("._SORTDESCENDING.")";
    elseif ($orderby == "hitsD") echo ""._SORTPAGEPOPULARITY." ("._SORTDESCENDING.")";
    elseif ($orderby == "reviewsD") echo ""._SORTPAGEREVIEWS." ("._SORTDESCENDING.")";
    elseif ($orderby == "scoresD") echo ""._SORTPAGESCORES." ("._SORTDESCENDING.")";
    else echo ""._NOTSORTED;
    echo "</font></center>"

    echo "</td>\n"
        ."</tr>";
*/
    $now = date("Y-m-d H:i:00");
    $column = &$pntable['subpages_column'];

// I don't need sorting, so the following code has been disabled
// CybLeNoir
/*
    if ($orderby == "titleA") $orderbycolumn = "$column[pagetitle] ASC,";
    elseif ($orderby == "authorA") $orderbycolumn = "$column[pageauthor] ASC,";
    elseif ($orderby == "datetimeA") $orderbycolumn = "$column[pagedatetime] ASC,";
    elseif ($orderby == "hitsA") $orderbycolumn = "$column[pagecounter] ASC,";
    elseif ($orderby == "reviewsA") $orderbycolumn = "$column[reviewscount] ASC,";
    elseif ($orderby == "scoresA") $orderbycolumn = "$column[reviewsscore] ASC,";
    elseif ($orderby == "titleD") $orderbycolumn = "$column[pagetitle] DESC,";
    elseif ($orderby == "authorD") $orderbycolumn = "$column[pageauthor] DESC,";
    elseif ($orderby == "datetimeD") $orderbycolumn = "$column[pagedatetime] DESC,";
    elseif ($orderby == "hitsD") $orderbycolumn = "$column[pagecounter] DESC,";
    elseif ($orderby == "reviewsD") $orderbycolumn = "$column[reviewscount] DESC,";
    elseif ($orderby == "scoresD") $orderbycolumn = "$column[reviewsscore] DESC,";
    else $orderbycolumn = "";
*/

    $result = $dbconn->Execute("SELECT $column[pageid], $column[subid], $column[pagetitle],  $column[pageimage],
                                  $column[pagetext], $column[pageauthor], $column[pageauthoremail],
                                  $column[pageauthorurl], $column[pagedatetime], $column[pagecounter],
                                  $column[reviewactive], $column[reviewscount], $column[reviewsscore]
                                FROM $pntable[subpages]
                                WHERE $column[parentpageid]=0 AND $column[subid]=$subid AND
                                  $column[pageactive] = 1 AND $column[pagedatetime] < '$now'
                                ORDER BY $column[pageorder]");
    if (!$result->EOF) {
       while(list($pageid, $subid, $pagetitle, $pageimage, $pagetext, $pageauthor, $pageauthoremail, $pageauthorurl, $pagedatetime, $pagecounter, $reviewactive, $reviewscount, $reviewsscore) = $result->fields) {
           if (authorised(0, 'Subjects::Page', "$pagetitle:$subname:$pageid", ACCESS_READ)) {
               echo "<tr>";
                if($pageimage != '')
                    echo "  <td valign=\"top\"><a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$pageid\"><img src=\"modules/$ModName/pages/$pageimage\" border=\"0\" Alt=\"$pagetitle\"></a></td>\n";
                else
                    echo "  <td valign=\"top\"></td>\n";
               echo "<td width=\"100%\" valign=\"top\">";

// I don't want graphics mark for new pages, so the following function call is disabled
// CybLeNoir

//               newpagegraphic($pagedatetime);
               echo "<h2><a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$pageid\">$pagetitle</a></h2>";
               if($pageauthor != ""){
                   echo "<em>$pageauthor</em>";
                   if($pageauthoremail != "")
                       echo " <a href=\"mailto:$pageauthoremail\"><img src=\"modules/$ModName/images/email.gif\" border=\"0\" alt=\""._PAGEAUTHOREMAIL."\"></a>";
               }
               if($pageauthorurl != "")
                   echo " <a href=\"$pageauthorurl\" target=\"_blank\"><img src=\"modules/$ModName/images/url.gif\" border=\"0\" alt=\""._PAGEAUTHORURL."\"></a>";

               echo "<br>"
                   ."$pagetext"
                   ."<hr noshade size=\"1\"><br></td></tr>";

           }
           $result->MoveNext();
       }
    } else
        echo "<tr><td align=\"center\">"._NOPAGES."</td></tr>";

    echo "<tr><td align=\"right\" colspan=\"2\">";
    echo "<HR noshade size=\"1\">"
        ."<a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index\">"._SUBJECTSRETURN."</a>";
                echo "</td></tr>";
                echo "</table>";
    $result->Close();

    CloseTable();

    include ('footer.php');
}

//----------------------------------------------------------------------
//view page
function viewpage($pageid, $pageno)
{
    global $pntable, $ModName, $subjectsconfig;
    list($dbconn) = pnDBGetConn();

    //Get page data from database
                // flag field subpagesindexactive added by CybLeNoir - 03/01/2003
    $column = &$pntable['subpages_column'];
    $subcolumn = &$pntable['subjects_column'];
    $result = $dbconn->Execute("SELECT $column[pageid], $column[parentpageid],
                           $column[subid], $subcolumn[subname], $column[pagetitle],
                           $column[pagecontent], $column[pagefile], $column[pageimage],
                           $column[pageauthor], $column[pageauthoremail], $column[pageauthorurl],
                           $column[pagedatetime], $column[pagecounter],
                           $column[reviewactive], $column[reviewscount], $column[reviewsscore], $column[subpagesindexactive]
                           FROM $pntable[subpages], $pntable[subjects]
                           WHERE $column[subid]=$subcolumn[subid] AND $column[pageid]=$pageid");
    list($pageid, $parentpageid, $subid, $subname, $pagetitle, $pagecontent, $pagefile,
         $pageimage, $pageauthor, $pageauthoremail, $pageauthorurl, $pagedatetime, $pagecounter, $reviewactive, $reviewscount, $reviewsscore, $subpagesindexactive) = $result->fields;
    $result->Close();















    if(!isset($pageid)) {
        include("header.php");
        OpenTable();
        echo _PAGEDOESNOTEXIST;
        CloseTable();
        include("footer.php");
        return;
    }

    list($mainpageid, $mainpagetitle) = getmainpageinfo($pageid);
    if (!authorised(0, 'Subjects::Page', "$mainpagetitle:$subname:$mainpageid", ACCESS_READ)) {
        include("header.php");
        OpenTable();
        echo _SUBJECTSPAGENOAUTH;
        CloseTable();
        include("footer.php");
        return;
    }

    include("header.php");

    OpenTable();

    if (!isset($pageno))
        $pageno = 1;

    //Page counter update
    if (($pageno == 1) OR ($pageno == "")) {
        $column = &$pntable['subpages_column'];
        $result = $dbconn->Execute("UPDATE $pntable[subpages]
                                  SET $column[pagecounter]=$column[pagecounter]+1
                                  WHERE $column[pageid]='$pageid'");
        $result->Close();
    }

    //Get page content from the file (if there is a path)
    if($pagefile != ''){
      if(file_exists("modules/$ModName/pages/$pagefile"))
        $pagecontent = join('', file("modules/$ModName/pages/$pagefile"));
      else
        $pagecontent = _FILECONTENTNOTEXISTS;
    }
// visto che  sempre uguale, scriviamolo una volta per tutte :-)
$urlviewprefix = "modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=";

    //Get subject info for the page and make a page context (ex. MainPage/SubPage/SubSubPage/...)
    if($parentpageid == 0){
        $mainpageid = $pageid;
        $mainpagetitle = $pagetitle;
        $mainpageimage = $pageimage;
        $mainpageauthor = $pageauthor;
        $mainpageauthoremail = $pageauthoremail;
        $mainpageauthorurl = $pageauthorurl;
        $mainpagedatetime = $pagedatetime;
        $mainreviewactive = $reviewactive;
        $mainreviewscount = $reviewscount;
        $mainreviewsscore = $reviewsscore;
    }else{
        $pagecontext = "$pagetitle";
        $context_parentpageid = $parentpageid;
        while($context_parentpageid > 0){
            $column = &$pntable['subpages_column'];
            $result = $dbconn->Execute("SELECT $column[pageid], $column[parentpageid], $column[pagetitle], $column[pageimage],
                                       $column[pageauthor], $column[pageauthoremail], $column[pageauthorurl],
                                       $column[pagedatetime], $column[reviewactive],
                                       $column[reviewscount], $column[reviewsscore]
                                       FROM $pntable[subpages] WHERE $column[pageid]=$context_parentpageid");
            list($context_pageid, $context_parentpageid, $context_pagetitle, $context_pageimage, $context_pageauthor, $context_pageauthoremail, $context_pageauthorurl, $context_pagedatetime, $context_reviewactive, $context_reviewscount, $context_reviewsscore) = $result->fields;
            $result->Close();
            if($context_parentpageid != 0)
// old context
// $pagecontext = "$context_pagetitle/".$pagecontext;
// CybLeNoir
// ==============================

// new context
                $pagecontext = "<a href=\"" . $urlviewprefix . $context_pageid . "\">$context_pagetitle</a>&nbsp;&gt;&nbsp;".$pagecontext;

            else{
                $mainpageauthor = $context_pageauthor;
                $mainpageauthoremail = $context_pageauthoremail;
                $mainpageauthorurl = $context_pageauthorurl;
                $mainpageid = $context_pageid;
                $mainpagetitle = $context_pagetitle;
                $mainpageimage = $context_pageimage;
                $mainpagedatetime = $context_pagedatetime;
                $mainreviewactive = $context_reviewactive;
                $mainreviewscount = $context_reviewscount;
                $mainreviewsscore = $context_reviewsscore;
            }
        }
    }

                // command !!indexsubpageslist!! added
                // function viewsubpageslist modified, see below
                //- CybLeNoir - 24/01/2003
    $pagecontent = eregi_replace("!!subpageslist!!", viewsubpageslist($pageid,0), $pagecontent);
                $pagecontent = eregi_replace("!!indexsubpageslist!!", viewsubpageslist($pageid,1), $pagecontent);
    $pagecontent = eregi_replace("!!pagesdir!!", "modules/$ModName/pages", $pagecontent);

    //Page break
    $contentpages = explode( "!!pagebreak!!", $pagecontent );
    $pagecount = count($contentpages);
    if ( $pageno=="" || $pageno < 1 )
        $pageno = 1;
    if ( $pageno > $pagecount )
        $pageno = $pagecount;
    $arrayelement = (int)$pageno;
    $arrayelement --;

    echo "<table border=\"0\" width=\"100%\" summary=\"layout\">";

// top navigator
// CybLeNoir
// ==============================
                echo "<tr><td align=\"right\">";
                // subject
                echo "<a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid\">$subname</a>";

                // pages path
                if ($pagecontext != "") {
                        echo "&nbsp;&gt;&nbsp;<a href=\"$urlviewprefix $mainpageid\">$mainpagetitle</a>";
                        echo "&nbsp;&gt;&nbsp;$pagecontext";
                }
                else
                {
                  echo "&nbsp;&gt;&nbsp;$mainpagetitle";
                }
                echo "<hr noshade size=\"1\">";
                echo "</td></tr>";
// end top navigator

// Title
                echo "<tr>\n<td>\n";
    echo "<h1>$pagetitle</h1>";
// End title



    if($mainpageauthor != ""){
        echo "<br>$mainpageauthor";
        if($mainpageauthoremail != "")
            echo " <a href=\"mailto:$mainpageauthoremail\"><img src=\"modules/$ModName/images/email.gif\" border=\"0\" alt=\""._PAGEAUTHOREMAIL."\"></a>";
    }
    if($mainpageauthorurl != "")
        echo " <a href=\"$mainpageauthorurl\" target=\"_blank\"><img src=\"modules/$ModName/images/url.gif\" border=\"0\" alt=\""._PAGEAUTHORURL."\"></a>";
    if($mainpageimage != '')
        echo "<br><br><img src=\"modules/$ModName/pages/$mainpageimage\" border=\"0\" Alt=\"$mainpagetitle\">\n";
    echo "  </td>\n"
        ."</tr>\n"
        ."<tr>\n";
    setlocale (LC_TIME, $locale);
    eregi("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $mainpagedatetime, $mainpagedate);
    $mainpagedate = ml_ftime(""._LINKSDATESTRING."", mktime($mainpagedate[4],$mainpagedate[5],$mainpagedate[6],$mainpagedate[2],$mainpagedate[3],$mainpagedate[1]));
    $mainpagedate = ucfirst($mainpagedate);
    echo "  <td align=\"right\" colspan=\"2\"> ("._PAGEDATETIME." $mainpagedate, "._PAGEREADS." $pagecounter";
    if($mainreviewactive == 1) {
        if($mainreviewscount > 0) {
            echo ", <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=pagereview&amp;pageid=$mainpageid\">"._REVIEWS.": $mainreviewscount</a> ";
            echo displayscore($mainreviewsscore/$mainreviewscount);
        } else
            echo ", <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=pagereview&amp;pageid=$mainpageid\">"._REVIEW."</a>";
    }
    echo ")&nbsp;<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=printpage&amp;pageid=$pageid&amp;scope=all\" target=\"_blank\"><img src=\"modules/$ModName/images/print_all.gif\" border=\"0\" Alt=\""._PAGEPRINTALL."\" width=\"15\" height=\"11\"></a>"
            ."&nbsp;<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=printpage&amp;pageid=$pageid&amp;scope=page\" target=\"_blank\"><img src=\"modules/$ModName/images/print_page.gif\" border=\"0\" Alt=\""._PAGEPRINTPAGE."\" width=\"15\" height=\"11\"></a><br></td>"
        ."</tr></table>";

    CloseTable();

    OpenTable();
    //Print page content

    echo "<font class=\"pn-normal\">$contentpages[$arrayelement]</font>";
    if($pageno >= $pagecount)
      $next_page = "";
    else {
        $next_pagenumber = $pageno + 1;
        $next_page .= "<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$pageid&amp;pageno=$next_pagenumber\"><img src=\"modules/$ModName/images/next.gif\" border=\"0\" alt=\""._NEXT."\"></a>";
    }
    if($pageno <= 1)
        $previous_page = "";
    else {
        $previous_pagenumber = $pageno - 1;
        $previous_page = "<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$pageid&amp;pageno=$previous_pagenumber\"><img src=\"modules/$ModName/images/prev.gif\" border=\"0\" alt=\""._PREVIOUS."\"></a>";
    }
    if($next_page != "" || $previous_page != "")
        echo "<center><br><br>$previous_page "._PAGENO.": $pageno/$pagecount $next_page<br><br></CENTER>";
    CloseTable();

    OpenTable();
    $subpages = getsubpages($mainpageid);
    if(isset($subpages)){
        $is_prevpage = false;
        $is_nextpage = false;
        $prevpageid = 0;
        $nextpageid = 0;
        reset($subpages);
        if($pageid == $mainpageid){ //main page
            $is_nextpage = true;
            $pagefields = current($subpages);
            $nextpageid = $pagefields[pageid];
        } else{ //first subpage
            $pagefields = current($subpages);
            $is_prevpage = true;
            if($pageid == $pagefields[pageid])
            {
                $prevpageid = $mainpageid;
                if($pagefields = next($subpages)){
                    $is_nextpage = true;
                    $nextpageid = $pagefields[pageid];
                }
            } else{ //next subpages
                $prevpageid = $pagefields[pageid];
                while($pagefields = next($subpages)) {
                    if($pagefields[pageid] == $pageid){
                      if($pagefields = next($subpages)){
                          $is_nextpage = true;
                          $nextpageid = $pagefields[pageid];
                      }
                      break;
                    }
                    $prevpageid = $pagefields[pageid];
                }
            }
        }
// Show subpages index if option is active
// flag field subpagesindexactive added by CybLeNoir - 03/01/2003
// ==============================
switch ($subpagesindexactive) {
case 2: {
        echo "<form method=\"post\">\n"
            ."<table border=\"0\" width=\"100%\" summary=\"layout\">\n"
            ."  <tr>\n"
            ."    <td align=\"left\">";
        if($is_prevpage)
            echo "<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$prevpageid\"><img src=\"modules/$ModName/images/prev.gif\" border=\"0\" alt=\""._PREVIOUS."\"></a>";
        echo "    </td>\n"
            ."    <td align=\"center\">";
        echo ""._SUBPAGESLIST.": <select class=\"pn-text\" name=\"newpage\" onChange=\"top.location.href=this.options[this.selectedIndex].value\">";

        if($pageid == $mainpageid)
            $selected = "selected";
        else
            $selected = "";
        echo "<option value=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$mainpageid\" $selected>$mainpagetitle</option>\n";
        foreach ($subpages as $pagefields) {
            $level = str_repeat("--", $pagefields[pagelevel]+1);
            $level = $level.">";
            if($pagefields[pageid] == $pageid)
                $selected = "selected";
            else
                $selected = "";
            echo "<option value=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$pagefields[pageid]\" $selected>$level$pagefields[pagetitle]</option>\n";
        }
        echo "</select>"
            ."    </td>\n"
            ."    <td align=\"right\">";
        if($is_nextpage)
            echo "<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$nextpageid\"><img src=\"modules/$ModName/images/next.gif\" border=\"0\" alt=\""._NEXT."\"></a><br>";
        echo "    </td>\n"
            ."  </tr>\n"
            ."</table>"
            ."</form>";
                        }
                        break;
   case 1: {

// subpages index: new version
// very similar to function viewsubpageslist($pageid) but with enhanced graphics and navigation devices
// CybLeNoir
// ==============================
        echo "<table border=\"0\" width=\"100%\" align=\"center\" summary=\"layout\">\n"
            ."  <tr>\n";
        echo "    <td>";


        if($pageid == $mainpageid)
            $selected = "<img src=\"modules/$ModName/images/active.gif\" alt=\"Pagina attiva\" border=\"0\">";
        else
            $selected = "";


        echo ("<h3><a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$mainpageid\">" . $mainpagetitle . "</a>" . $selected . " - " ._SUBPAGESLIST .":</h3>\n");

                                foreach ($subpages as $pagefields) {
            $level = str_repeat("&nbsp;&nbsp;&nbsp;", $pagefields[pagelevel]+1);
                                                // the following image is ok for my website; change it as you like
                                                // CybLeNoir - 03/01/2003
            $level = $level . "<img src=\"modules/$ModName/images/index_arrow.gif\" width=\"4\" height=\"8\" alt=\"\">&nbsp;";

            if($pagefields[pageid] == $pageid)
                $selected = "<img src=\"modules/$ModName/images/active.gif\" alt=\"Pagina attiva\" border=\"0\">";
            else
                $selected = "";
            echo ($level . "<a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$pagefields[pageid]\">" . $pagefields[pagetitle] . "</a>" . $selected . "</br>\n");
        }

        echo "    </p></td>\n";
        echo "  </tr>\n"
            ."</table>";

            }
                        break;
                 }

                }

// bottom navigator
// CybLeNoir
// ==============================
                echo "<tr><td align=\"right\">";
                echo "<hr noshade size=\"1\">";
                // radice
                echo "<a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid\">$subname</a>";

                // percorso
                if ($pagecontext != "") {
                        echo "&nbsp;&gt;&nbsp;<a href=\"$urlviewprefix $mainpageid\">$mainpagetitle</a>";
                        echo "&nbsp;&gt;&nbsp;$pagecontext";
                }
                else
                {
                  echo "&nbsp;&gt;&nbsp;$mainpagetitle";
                }

                echo "</td></tr>";
// end bottom navigator
   CloseTable();

    include ('footer.php');
}

//----------------------------------------------------------------------
//display score
function displayscore($score)
{
    global $ModName;

    $score /= 2;
    $max_score = 5;
    $star_full = "modules/$ModName/images/star_full.gif";
    $star_half = "modules/$ModName/images/star_half.gif";
    $star_none = "modules/$ModName/images/star_none.gif";

    // Break up score
    if (strpos($score, ".")==0)
        $full_stars = $score;
    else
        $full_stars = substr($score, 0, strpos($score, "."));

    // *** Is there half star
    if (substr($score, strpos($score, ".") + 1) == 0)
        $half_stars = 0;
    else
        $half_stars = 1;

    // *** Build Star Line
    $blank_stars = $max_score - ($full_stars + $half_stars);
    $star_line = "";
    for ($i = 1; $i <= $max_score; $i++){
        if ($i <= $full_stars)
            $star_line .= "<img src='".$star_full."' border='0'>";
        elseif ($i <= ($half_stars + $full_stars))
            $star_line .= "<img src='".$star_half."' border='0'>";
        elseif ($i <= $max_score)
            $star_line .= "<img src='".$star_none."' border='0'>";
    }
    return $star_line;
}

//----------------------------------------------------------------------
//page review
function pagereview($pageid)
{
    global $pntable, $ModName, $subjectsconfig, $user, $cookie, $anonymous;
    list($dbconn) = pnDBGetConn();

    //Get page data from database
    $column = &$pntable['subpages_column'];
    $subcolumn = &$pntable['subjects_column'];
    $result = $dbconn->Execute("SELECT $column[pageid], $column[parentpageid],
                           $column[subid], $subcolumn[subname], $column[pagetitle],
                           $column[pagetext],
                           $column[pageauthor], $column[pageauthoremail], $column[pageauthorurl],
                           $column[pagedatetime], $column[pagecounter],
                           $column[reviewactive],
                           $column[reviewscount], $column[reviewsscore]
                           FROM $pntable[subpages], $pntable[subjects]
                           WHERE $column[subid]=$subcolumn[subid] AND $column[pageid]=$pageid");
    list($pageid, $parentpageid, $subid, $subname, $pagetitle, $pagetext, $pageauthor, $pageauthoremail, $pageauthorurl, $pagedatetime, $pagecounter, $reviewactive, $reviewscount, $reviewsscore) = $result->fields;
    $result->Close();

    if(!isset($pageid)) {
        include("header.php");
        OpenTable();
        echo _PAGEDOESNOTEXIST;
        CloseTable();
        include("footer.php");
        return;
    }

    if($parentpageid != 0) {
        include("header.php");
        OpenTable();
        echo _CANNOTREVIEWSUBPAGE;
        CloseTable();
        include("footer.php");
        return;
    }

    if($reviewactive != 1) {
        include("header.php");
        OpenTable();
        echo _CANNOTREVIEWPAGE;
        CloseTable();
        include("footer.php");
        return;
    }

    if (!authorised(0, 'Subjects::Page', "$pagetitle:$subname:$pageid", ACCESS_READ)) {
        include("header.php");
        OpenTable();
        echo _SUBJECTSPAGENOAUTH;
        CloseTable();
        include("footer.php");
        return;
    }

    include("header.php");

    OpenTable();
    echo "<table border=\"0\" width=\"100%\" summary=\"layout\">"
        ."<tr>\n"
        ."  <td align=\"center\">\n"
        ."<a class=\"pn-title\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$pageid\">$pagetitle</a>";
    if($pageauthor != ""){
        echo "<br>$pageauthor";
        if($pageauthoremail != "")
            echo " <a href=\"mailto:$pageauthoremail\"><img src=\"modules/$ModName/images/email.gif\" border=\"0\" alt=\""._PAGEAUTHOREMAIL."\"></a>";
    }
    if($pageauthorurl != "")
        echo " <a href=\"$pageauthorurl\" target=\"_blank\"><img src=\"modules/$ModName/images/url.gif\" border=\"0\" alt=\""._PAGEAUTHORURL."\"></a>";
    echo "  </td>\n"
        ."</tr>\n"
        ."<tr>\n";
    setlocale (LC_TIME, $locale);
    eregi("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $pagedatetime, $pagedate);
    $pagedate = ml_ftime(""._LINKSDATESTRING."", mktime($pagedate[4],$pagedate[5],$pagedate[6],$pagedate[2],$pagedate[3],$pagedate[1]));
    $pagedate = ucfirst($pagedate);
    echo "  <td align=\"right\" colspan=\"2\"> ("._PAGEDATETIME." $pagedate, "._PAGEREADS." $pagecounter, ";
    if($reviewscount > 0) {
        echo "<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=pagereview&amp;pageid=$pageid\">"._REVIEWS.": $reviewscount</a> ";
        echo displayscore($reviewsscore/$reviewscount);
    } else
        echo "<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=pagereview&amp;pageid=$pageid\">"._REVIEW."</a>";
    echo ")&nbsp;<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=printpage&amp;pageid=$pageid&amp;scope=all\" target=\"_blank\"><img src=\"modules/$ModName/images/print.gif\" border=\"0\" Alt=\""._PAGEPRINTALL."\" width=\"15\" height=\"11\"></a><br></td>"
        ."</tr></table>";
    CloseTable();

    $column = &$pntable['subreviews_column'];
    $result = $dbconn->Execute("SELECT $column[reviewid], $column[reviewtitle], $column[reviewcomments],
                           $column[reviewscore], $column[reviewuser],
                           $column[reviewhostip], $column[reviewdatetime]
                           FROM $pntable[subreviews]
                           WHERE $column[pageid]=$pageid
                           ORDER BY $column[reviewdatetime]");
    //view page reviews
    if(!$result->EOF) {
        OpenTable();

        echo "<center><font class=\"pn-title\"><b>"._PAGEREVIEWS."</b></font></center><br><br>"
            ."<table border=\"0\" align=\"center\" width=\"90%\" summary=\"layout\">";

        while(list($reviewid, $reviewtitle, $reviewcomments, $reviewscore, $reviewuser, $reviewhostip, $reviewdatetime) = $result->fields) {
           echo "<tr><td align=\"left\">";
           setlocale (LC_TIME, $locale);
           eregi("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $reviewdatetime, $reviewdate);
           $reviewdate = ml_ftime(_DATETIMEBRIEF, mktime($reviewdate[4],$reviewdate[5],$reviewdate[6],$reviewdate[2],$reviewdate[3],$reviewdate[1]));
           $reviewdate = ucfirst($reviewdate);
           echo displayscore($reviewscore);
           echo " <b>$reviewtitle</b>, <a href=\"user.php?op=userinfo&amp;uname=$reviewuser\">$reviewuser</a>, $reviewdate";
           if(authorised(0, 'Subjects::Page', "$pagetitle:$subname:$pageid", ACCESS_ADMIN)) {
               echo ", ($reviewhostip) ";
               echo " [ <a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=reviewdelete&amp;reviewid=$reviewid&amp;ok=0\">"._DELETE."</a> ]";
               //echo " [ <a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=reviewedit&amp;reviewid=$reviewid\">"._EDIT."</a>"
               //    ." | <a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=reviewdelete&amp;reviewid=$reviewid&amp;ok=0\">"._DELETE."</a> ]";
           }
           echo "<br><font class=\"pn-normal\">$reviewcomments</font>"
               ."</td></tr>"
               ."<tr>\n"
               ."  <td>&nbsp;</td>\n"
               ."</tr>";
           $result->MoveNext();
        }
        echo "</table><br><br>";
        echo "<center><small>"._REVIEWSWARNING."</small></center>";
        CloseTable();
    }
    $result->Close();

    //add page review
    if (authorised(0, 'Subjects::Page', "$pagetitle:$subname:$pageid", ACCESS_COMMENT)) {
        OpenTable();

        echo "<center><font class=\"pn-title\"><b>"._ADDPAGEREVIEW."</b></font></center><br><br>";

        echo "<form action=\"modules.php\" method=\"post\">"
            ."<input type=\"hidden\" name=\"op\" value=\"modload\">\n"
            ."<input type=\"hidden\" name=\"name\" value=\"$ModName\">\n"
            ."<input type=\"hidden\" name=\"file\" value=\"index\">\n"
            ."<input type=\"hidden\" name=\"req\" value=\"reviewadd\">\n"
            ."<input type=\"hidden\" name=\"pageid\" value=\"$pageid\">";
        echo "<b>"._REVIEWERNAME.":</b> ";
        if (is_user($user)) {
            cookiedecode($user);
            echo "<a href=\"user.php\">$cookie[1]</a><br><br>";
        } else
            echo "$anonymous [ <a class=\"pn-normal\" href=\"user.php\">"._NEWUSER."</a> ]<br><br>";
        echo "<b>"._REVIEWTITLE."</b> "._REQUIREDFILED."<br>"
            ."<input type=\"text\" name=\"reviewtitle\" size=\"60\"><br><br>"
            ."<b>"._REVIEWCOMMENTS."</b><br><textarea wrap=\"virtual\" cols=\"50\" rows=\"10\" name=\"reviewcomments\"></textarea><br>"
            .""._ALLOWEDHTML."<br>";
        while (list($key,)= each(pnConfigGetVar('AllowableHTML'))) echo " &lt;".$key."&gt;";
        echo "<br><br><b>"._REVIEWSCORE."</b> "._REQUIREDFILED."<br>"
            ."<select name=\"reviewscore\">"
            ."<option>--</option>"
            ."<option>10</option>"
            ."<option>9</option>"
            ."<option>8</option>"
            ."<option>7</option>"
            ."<option>6</option>"
            ."<option>5</option>"
            ."<option>4</option>"
            ."<option>3</option>"
            ."<option>2</option>"
            ."<option>1</option>"
            ."</select><br><br>"
            ."<input type=\"submit\" value=\""._REVIEWTHISPAGE."\">"
            ."</form>";

        CloseTable();
    }

    OpenTable();
    echo "<center><font class=\"pn-normal\">[<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=listpages&amp;subid=$subid\">"._SUBJECTRETURN." <b>$subname</b></a> | <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index\">"._SUBJECTSRETURN."</a> ]</font></center>";
    CloseTable();

    include ('footer.php');
}

//----------------------------------------------------------------------
//add review to database
function reviewadd($pageid, $reviewtitle, $reviewcomments, $reviewscore)
{
    global $user, $userinfo, $cookie, $pntable, $ModName, $anonymous;
    list($dbconn) = pnDBGetConn();

    $column = &$pntable['subpages_column'];
    $subcolumn = &$pntable['subjects_column'];
    $result = $dbconn->Execute("SELECT $column[parentpageid],
                           $subcolumn[subname], $column[pagetitle], $column[reviewactive]
                           FROM $pntable[subpages], $pntable[subjects]
                           WHERE $column[subid]=$subcolumn[subid] AND $column[pageid]=$pageid");
    list($parentpageid, $subname, $pagetitle, $reviewactive) = $result->fields;
    $result->Close();

    if($parentpageid != 0) {
        include("header.php");
        OpenTable();
        echo _CANNOTREVIEWSUBPAGE;
        CloseTable();
        include("footer.php");
        return;
    }

    if($reviewactive != 1) {
        include("header.php");
        OpenTable();
        echo _CANNOTREVIEWPAGE;
        CloseTable();
        include("footer.php");
        return;
    }

    if (!authorised(0, 'Subjects::Page', "$pagetitle:$subname:$pageid", ACCESS_COMMENT)) {
        include("header.php");
        OpenTable();
        echo _SUBJECTSPAGENOAUTH;
        CloseTable();
        include("footer.php");
        return;
    }

    while (list($key,)= each(pnConfigGetVar('AllowableHTML'))) $allow_tags .= "<".$key.">";

    $reviewtitle = stripslashes(FixQuotes($reviewtitle));
    $reviewcomments = strip_tags(FixQuotes(check_words($reviewcomments), $allow_tags));

    if($user) getusrinfo($user);
    if ($user) {
        getusrinfo($user);
        $reviewuser = $userinfo[uname];
    } else
        $reviewuser = $anonymous;
    $reviewhostip = getenv("REMOTE_ADDR");

    if($user) {
        $column = &$pntable['subreviews_column'];
        $result = $dbconn->Execute("SELECT COUNT(*)
                               FROM $pntable[subreviews]
                               WHERE $column[pageid]='$pageid' AND
                                     $column[reviewuser]='$userinfo[uname]'");
        list($is_reviewed) = $result->fields;
        $result->Close();
    } else {
        $column = &$pntable['subreviews_column'];
        $result = $dbconn->Execute("SELECT COUNT(*)
                                  FROM $pntable[subreviews]
                                  WHERE $column[pageid]='$pageid' AND
                                        $column[reviewhostip]='$reviewhostip'");
        list($is_reviewed) = $result->fields;
        $result->Close();
    }

    if(trim($reviewtitle) == "" || $reviewscore == "--" || $is_reviewed){
        include("header.php");
        OpenTable();
        echo "<center><font class=\"pn-normal\"><b>"._ADDREVIEWERROR."</b></font></center><br><br>"
            ."<ul>";

        if($is_reviewed > 0) {
            echo "<li>"._PAGEALREADYREVIEWED.".";
        } else {
            if(trim($reviewtitle) == "")
                echo "<li>"._FILLTHEFIELD." <b>"._REVIEWTITLE."</b>.";
            if($reviewscore == "--")
                echo "<li>"._FILLTHEFIELD." <b>"._REVIEWSCORE."</b>.";
        }
        echo "</ul><br><center>"._PRESSBACK."</center>";
        CloseTable();
        include("footer.php");
    } else{
        $column = &$pntable['subreviews_column'];
        $nextid = $dbconn->GenId($pntable['subreviews']);
        $dbconn->Execute("INSERT INTO $pntable[subreviews] ($column[reviewid],
                            $column[pageid], $column[reviewtitle], $column[reviewcomments],
                            $column[reviewscore], $column[reviewuser], $column[reviewhostip],
                            $column[reviewdatetime])
                          VALUES ($nextid, '$pageid', '$reviewtitle', '$reviewcomments',
                                  '$reviewscore', '$reviewuser', '$reviewhostip',
                                  now())");

        $column = &$pntable['subpages_column'];
        $dbconn->Execute("UPDATE $pntable[subpages]
                        SET $column[reviewscount] = $column[reviewscount] + 1,
                            $column[reviewsscore] = $column[reviewsscore] + $reviewscore
                        WHERE $column[pageid]=$pageid");

        pnRedirect('modules.php?op=modload&name='.$ModName.'&file=index&req=pagereview&pageid='.$pageid);
    }
}

//----------------------------------------------------------------------
//delete review from database
function reviewdelete($reviewid, $ok=0)
{
    global $pntable, $ModName;
    list($dbconn) = pnDBGetConn();

    $column = &$pntable['subreviews_column'];
    $subcolumn = &$pntable['subjects_column'];
    $pagecolumn = &$pntable['subpages_column'];
    $result = $dbconn->Execute("SELECT $column[pageid], $column[reviewtitle],
                           $column[reviewscore],
                           $subcolumn[subname], $pagecolumn[pagetitle],
                           $pagecolumn[pageauthor], $pagecolumn[pageauthoremail],
                           $pagecolumn[pageauthorurl],
                           $pagecolumn[pagedatetime], $pagecolumn[pagecounter]
                           FROM $pntable[subreviews], $pntable[subpages], $pntable[subjects]
                           WHERE $column[reviewid] = $reviewid AND
                                 $column[pageid] = $pagecolumn[pageid] AND
                                 $pagecolumn[subid] = $subcolumn[subid]");
    list($pageid, $reviewtitle, $reviewscore, $subname, $pagetitle, $pageauthor, $pageauthoremail, $pageauthorurl, $pagedatetime, $pagecounter) = $result->fields;
    $result->Close();

    if (!authorised(0, 'Subjects::Page', "$pagetitle:$subname:$pageid", ACCESS_ADMIN)) {
        include("header.php");
        OpenTable();
        echo _SUBJECTSPAGENOAUTH;
        CloseTable();
        include("footer.php");
        return;
    }

    if ($ok==1) {
        $dbconn->Execute("DELETE FROM $pntable[subreviews]
                        WHERE {$pntable[subreviews_column][reviewid]}='$reviewid'");

        $column = &$pntable['subpages_column'];
        $dbconn->Execute("UPDATE $pntable[subpages]
                        SET $column[reviewscount] = $column[reviewscount] - 1,
                            $column[reviewsscore] = $column[reviewsscore] - $reviewscore
                        WHERE $column[pageid]=$pageid");

        pnRedirect('modules.php?op=modload&name='.$ModName.'&file=index&req=pagereview&pageid='.$pageid);
    } else {
        include("header.php");

        OpenTable();
        echo "<center><font class=\"pn-title\"><b>"._DELREVIEW."</b></font><br><br>";
        echo "<font class=\"pn-normal\"><b>$reviewtitle</b></font><br><br>";
        echo "<table summary=\"layout\"><tr><td>\n";
        echo myTextForm("modules.php?op=modload&amp;name=".$ModName."&amp;file=index&amp;req=pagereview&amp;pageid=$pageid", _NO);
        echo "</td><td>\n";
        echo myTextForm("modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=reviewdelete&amp;reviewid=$reviewid&amp;ok=1", _YES);
        echo "</td></tr></table>\n";
        echo "</center>\n";
        CloseTable();

        include("footer.php");
    }
}

//----------------------------------------------------------------------
//print page
function printpage($pageid, $scope)
{
    global $site_logo, $nukeurl, $sitename, $datetime, $pntable, $ModName,
           $ThemeSel, $subjectsconfig;
    list($dbconn) = pnDBGetConn();

    //Get page data from database
    $column = &$pntable['subpages_column'];
    $subcolumn = &$pntable['subjects_column'];
    $result = $dbconn->Execute("SELECT $column[pageid], $column[parentpageid],
                           $column[subid], $subcolumn[subname], $column[pagetitle],
                           $column[pagecontent], $column[pagefile],
                           $column[pageauthor], $column[pageauthoremail], $column[pageauthorurl],
                           $column[pagedatetime], $column[pagecounter]
                           FROM $pntable[subpages], $pntable[subjects]
                           WHERE $column[pageid]=$pageid AND
                           $column[subid]=$subcolumn[subid]");
    list($pageid, $parentpageid, $subid, $subname, $pagetitle, $pagecontent, $pagefile, $pageauthor, $pageauthoremail, $pageauthorurl, $pagedatetime, $pagecounter) = $result->fields;
    $result->Close();

    if(!isset($pageid)) {
        include("header.php");
        OpenTable();
        echo _PAGEDOESNOTEXIST;
        CloseTable();
        include("footer.php");
        return;
    }

    if(!isset($scope)) {
          $scope = "all";
        }

    list($mainpageid, $mainpagetitle) = getmainpageinfo($pageid);
    if (!authorised(0, 'Subjects::Page', "$mainpagetitle:$subname:$mainpageid", ACCESS_READ)) {
        include("header.php");
        OpenTable();
        echo _SUBJECTSPAGENOAUTH;
        CloseTable();
        include("footer.php");
        return;
    }

    //Get subject info for the page and make a page context (ex. MainPage/SubPage/SubSubPage/...)
    if($parentpageid == 0){
        $mainpageid = $pageid;
        $mainpagetitle = "<h1>".$pagetitle."</h1>\n";
        $mainpageauthor = $pageauthor;
        $mainpageauthoremail = $pageauthoremail;
        $mainpageauthorurl = $pageauthorurl;
        $mainpageid = $pageid;
        $mainpagedatetime = $pagedatetime;
    }else{
        $pagecontext = "<h2>$pagetitle</h2>";
        $context_parentpageid = $parentpageid;
        while($context_parentpageid > 0){
            $column = &$pntable['subpages_column'];
            $result = $dbconn->Execute("SELECT $column[pageid], $column[parentpageid], $column[pagetitle],
                                       $column[pageauthor], $column[pageauthoremail], $column[pageauthorurl],
                                       $column[pagedatetime]
                                       FROM $pntable[subpages] WHERE $column[pageid]=$context_parentpageid");
            list($context_pageid, $context_parentpageid, $context_pagetitle, $context_pageauthor, $context_pageauthoremail, $context_pageauthorurl, $context_pagedatetime) = $result->fields;
            $result->Close();
            if($context_parentpageid != 0)
                $pagecontext = "$context_pagetitle/".$pagecontext."\n";
            else{
                $mainpageauthor = $context_pageauthor;
                $mainpageauthoremail = $context_pageauthoremail;
                $mainpageauthorurl = $context_pageauthorurl;
                $mainpageid = $context_pageid;
                $mainpagetitle = "<h1>".$context_pagetitle."</h1>\n";
                $mainpagedatetime = $context_pagedatetime;
            }
        }
    }

    printheader();
    include("modules/$ModName/printheader.php");

    //Get page content from the file (if there is a path)
    if($pagefile != ''){
      if(file_exists("modules/$ModName/pages/$pagefile"))
        $pagecontent = join('', file("modules/$ModName/pages/$pagefile"));
      else
        $pagecontent = "<b><font color=\"red\">"._FILECONTENTNOTEXISTS." <i>$pagetitle</i>!</font></b>";
    }
    $pagecontent = eregi_replace("!!indexsubpageslist!!", printsubpageslist($pageid,1), $pagecontent);
                $pagecontent = eregi_replace('!!subpageslist!!', printsubpageslist($pageid,0), $pagecontent);
    $pagecontent = eregi_replace("!!pagesdir!!", "modules/$ModName/pages", $pagecontent);
    $pagecontent = eregi_replace("!!pagebreak!!", "", $pagecontent);
    echo "$pagecontent<br>";

    $pages = getsubpages($pageid);
    if(isset($pages) && $scope == "all"){

        foreach ($pages as $pagefields) {
            $column = &$pntable['subpages_column'];
            $result=$dbconn->Execute("SELECT $column[pagetitle], $column[pagecontent], $column[pagefile]
                                      FROM $pntable[subpages]
                                      WHERE $column[pageid]=$pagefields[pageid]");
            list($pagetitle, $pagecontent, $pagefile) = $result->fields;
            $result->Close();

            if($pagefile != '')
                $pagecontent = join('', file("modules/$ModName/pages/$pagefile"));

            if($pagefile != ''){
              if(file_exists("modules/$ModName/pages/$pagefile")){
                $pagecontent = join('', file("modules/$ModName/pages/$pagefile"));
              } else{
                $pagecontent = "<b><font color=\"red\">"._FILECONTENTNOTEXISTS." <i>$pagetitle</i>!</font></b>";
              }
            }
                                                $pagecontent = eregi_replace('!!indexsubpageslist!!', printsubpageslist($pagefields[pageid],1), $pagecontent);
            $pagecontent = eregi_replace('!!subpageslist!!', printsubpageslist($pagefields[pageid],0), $pagecontent);
            $pagecontent = eregi_replace("!!pagesdir!!", "modules/$ModName/pages", $pagecontent);
            $pagecontent = eregi_replace("!!pagebreak!!", "", $pagecontent);

                                                echo "<hr noshade size=\"1\">";
            echo "<a name=\"$pagefields[pageid]\"></a><br>";
                                                echo "<h2>$pagetitle</h2>";
            echo "$pagecontent<br>";
        }
    }

    include("modules/$ModName/printfooter.php");
    printfooter();
}

//----------------------------------------------------------------------
//print page header
function printheader() {
    global $index, $artpage, $topic, $hlpfile, $user, $hr, $theme, $cookie, $bgcolor1,
        $bgcolor2, $bgcolor3, $bgcolor4, $bgcolor5, $textcolor1, $textcolor2,
        $textcolor3, $textcolor4, $forumpage, $thename, $postnuke_theme,
        $pntheme, $themename, $themeimages, $additional_header;

        // modification mouzaia .71
        $cWhereIsPerso = WHERE_IS_PERSO;
        if(!empty($cWhereIsPerso))
        {
            global $themesarein;
            if (pnUserLoggedIn()) {
                $thistheme = pnUserGetTheme();
                if(isset ($theme)) {
                    $thistheme=$theme;
                }
            } else {
                $thistheme = pnConfigGetVar('Default_Theme');
                if (isset ($theme)) {
                    $thistheme=$theme;
                }
            }

            if (@file(WHERE_IS_PERSO."themes/".$thistheme."/theme.php")) {
                $themesarein = WHERE_IS_PERSO;
            } else {
                $themesarein = "";
            }
    }

    if(pnConfigGetVar('supportxhtml'))
    {
        //include("includes/xhtml.php");
        xhtml_head_start(0);     /* Transitional Support for now */
    }
    else {
        echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
            echo "<html>\n<head>\n";

        if (defined("_CHARSET") && _CHARSET != "") {
                echo "<meta http-equiv=\"Content-Type\" ".
                         "content=\"text/html; charset="._CHARSET."\">\n";
            }
    }

        echo '<title>'.pnConfigGetVar('sitename').' :: '.pnConfigGetVar('slogan').'</title>';
        echo '<meta name="KEYWORDS" content="'.pnConfigGetVar('metakeywords').'" />';
    echo '<meta name="DESCRIPTION" content="'.pnConfigGetVar('slogan').'" />';
    echo '<meta name="resource-type" content="document" />';
    echo '<meta http-equiv="expires" content="0" />';
    echo '<meta name="author" content="'.pnConfigGetVar('sitename').'" />';
    echo '<meta name="copyright" content="Copyright (c) 2001 by '.pnConfigGetVar('sitename').'" />';
    echo '<meta name="distribution" content="Global" />';
    echo '<META NAME="Authoring_tool" CONTENT="CS Pajczek 2000 PRO v4.8.1">';
    echo '<meta name="rating" content="General" />';

    global $themesarein;

    echo "<link rel=\"StyleSheet\" href=\"".$themesarein."themes/" . pnUserGetTheme() . "/style/styleNN.css\" type=\"text/css\" />\n";
    echo "<style type=\"text/css\">";
    echo "@import url(\"".$themesarein."themes/".pnUserGetTheme()."/style/style.css\"); ";

    echo "</style>\n";
    echo "<html>\n";
    echo "<body>\n";
}

//----------------------------------------------------------------------
//print page footer
function printfooter() {
    echo "</body>\n"
        ."</html>";
}

//----------------------------------------------------------------------
// print subpages lists with or without description
// modified by CybLeNoir - 26/03/2003
function printsubpageslist($pageid,$rich)
{
    global $pntable, $ModName;
    list($dbconn) = pnDBGetConn();

    $column = &$pntable['subpages_column'];
    $result=$dbconn->Execute("SELECT $column[pageid], $column[pagetitle]
                            FROM $pntable[subpages]
                            WHERE $column[pageactive] = 1 AND
                            $column[parentpageid]=$pageid
                            ORDER BY $column[pageorder]");
    if (!$result->EOF){
                  if ($rich == 1) {
        while(list($pageid, $pagetitle, $pagetext) = $result->fields){
                                        $ret = $ret."<h2><a href=\"#$pageid\">$pagetitle</a></h2>\n";
                                        $ret = $ret."<p style=\"margin-left: 10pt\">$pagetext</p>";
          $result->MoveNext();
                }

                                }
                        else {
        $ret = $ret."<ul>";
        while(list($pageid, $pagetitle) = $result->fields){
          $ret = $ret."<li><a class=\"pn-title\" href=\"#$pageid\">$pagetitle</a>\n";
          $ret = $ret.printsubpageslist($pageid,0);
          $result->MoveNext();
        }
        $ret = $ret."</ul>";
                                }
    }
    $result->Close();

    return $ret;
}



//----------------------------------------------------------------------
//view subpages lists with or without description
// modified by CybLeNoir - 23/03/2003
function viewsubpageslist($pageid,$rich)
{
    global $pntable, $ModName;
    list($dbconn) = pnDBGetConn();

    $column = &$pntable['subpages_column'];
    $result=$dbconn->Execute("SELECT $column[pageid], $column[pagetitle], $column[pagetext]
                            FROM $pntable[subpages]
                            WHERE $column[pageactive] = 1 AND
                            $column[parentpageid]=$pageid
                            ORDER BY $column[pageorder]");
    if (!$result->EOF){
        if ($rich == 1) {
          while(list($pageid, $pagetitle, $pagetext) = $result->fields){
            $ret = $ret."<h2><a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$pageid\">$pagetitle</a></h2>\n";
                                                $ret = $ret."<p style=\"margin-left: 10pt\">$pagetext</p>";
            $result->MoveNext();
          }
                                }
                                else
                                {
                                  $ret = $ret."<ul>";
          while(list($pageid, $pagetitle) = $result->fields){
            $ret = $ret."<li><a href=\"modules.php?op=modload&amp;name=$ModName&amp;file=index&amp;req=viewpage&amp;pageid=$pageid\">$pagetitle</a>\n";
            $ret = $ret.viewsubpageslist($pageid,$rich);
            $result->MoveNext();
          }
                                }
        $ret = $ret."</ul>";

    }
    $result->Close();

    return $ret;
}

function getsubpages($pageid, $pagelevel = 0)
{
    global $pntable, $ModName;
    list($dbconn) = pnDBGetConn();

    $column = &$pntable['subpages_column'];
    $result=$dbconn->Execute("SELECT $column[pageid], $column[pagetitle]
                            FROM $pntable[subpages]
                            WHERE $column[pageactive] = 1 AND
                            $column[parentpageid]=$pageid
                            ORDER BY $column[pageorder]");
    if (!$result->EOF){
        while(list($pageid, $pagetitle) = $result->fields){
            $ret[$pageid] = array('pageid' => $pageid,
                                  'pagetitle' => $pagetitle,
                                  'pagelevel' => $pagelevel);
            $ret = array_merge($ret, getsubpages($pageid, $pagelevel+1));
            $result->MoveNext();
        }
    }
    $result->Close();

    return $ret;
}


function subjectnewpagegraphic($subid) {
    global $pntable, $ModName, $locale;
    list($dbconn) = pnDBGetConn();

    $now = date("Y-m-d H:i:00");
    $column = &$pntable['subpages_column'];
    $result = $dbconn->SelectLimit("SELECT $column[pagedatetime]
                              FROM $pntable[subpages]
                              WHERE $column[subid] = $subid AND
                              $column[pageactive] = 1 AND $column[parentpageid] = 0 AND
                              $column[pagedatetime] < '$now'
                              ORDER BY $column[pagedatetime] DESC", 1);
    if(!$result->EOF){
        list($datetime)=$result->fields;
        setlocale (LC_TIME, $locale);
        eregi("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $datetime, $dt);
        $dt = ml_ftime(""._LINKSDATESTRING."", mktime($dt[4],$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));
        $dt = ucfirst($dt);
        $startdate = time();
        $count = 0;
        while ($count <= 7) {
            $daysold = ml_ftime(""._LINKSDATESTRING."", $startdate);
            if ("$daysold" == "$dt") {
                if ($count<=1) {
                    echo "<img src=\"modules/$ModName/images/new_1.gif\" alt=\""._NEWTODAY."\">&nbsp;";
                }
                if ($count<=3 && $count>1) {
                    echo "<img src=\"modules/$ModName/images/new_3.gif\" alt=\""._NEWLAST3DAYS."\">&nbsp;";
                }
                if ($count<=7 && $count>3) {
                    echo "<img src=\"modules/$ModName/images/new_7.gif\" alt=\""._NEWTHISWEEK."\">&nbsp;";
                }
            }
            $count++;
            $startdate = (time()-(86400 * $count));
        }
    }
    $result->Close();
}



function newpagegraphic($datetime) {
    global $ModName, $locale;

    setlocale (LC_TIME, $locale);
    eregi("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})", $datetime, $dt);
    $dt = ml_ftime(""._LINKSDATESTRING."", mktime($dt[4],$dt[5],$dt[6],$dt[2],$dt[3],$dt[1]));
    $dt = ucfirst($dt);
    $startdate = time();
    $count = 0;
    while ($count <= 7) {
        $daysold = ml_ftime(""._LINKSDATESTRING."", $startdate);
        if ("$daysold" == "$dt") {
            if ($count<=1) {
                echo "<img src=\"modules/$ModName/images/new_1.gif\" alt=\""._NEWTODAY."\">&nbsp;";
            }
            if ($count<=3 && $count>1) {
                echo "<img src=\"modules/$ModName/images/new_3.gif\" alt=\""._NEWLAST3DAYS."\">&nbsp;";
            }
            if ($count<=7 && $count>3) {
                echo "<img src=\"modules/$ModName/images/new_7.gif\" alt=\""._NEWTHISWEEK."\">&nbsp;";
            }
        }
        $count++;
        $startdate = (time()-(86400 * $count));
    }
}


function getmainpageinfo($pageid)
{
    global $pntable;
    list($dbconn) = pnDBGetConn();

    $column = &$pntable['subpages_column'];
    $result = $dbconn->Execute("SELECT $column[parentpageid], $column[pagetitle]
                                FROM $pntable[subpages]
                                WHERE $column[pageid] = $pageid");
    list($parentpageid, $pagetitle) = $result->fields;
    $result->Close();

    if($parentpageid == 0){
        $mainpageid = $pageid;
        $mainpagetitle = $pagetitle;
    }else{
        while($parentpageid > 0){
            $result = $dbconn->Execute("SELECT $column[pageid], $column[parentpageid], $column[pagetitle]
                                       FROM $pntable[subpages]
                                       WHERE $column[pageid]=$parentpageid");
            list($mainpageid, $parentpageid, $pagetitle) = $result->fields;
            $result->Close();
        }
    }

    return array($mainpageid, $mainpagetitle);
}





switch($req) {
    case "viewpage":
        viewpage($pageid, $pageno);
        break;

    case "listpages":
        listpages($subid, $orderby);
        break;

    case "printpage":
        printpage($pageid, $scope);
        break;

    case "pagereview":
        pagereview($pageid);
        break;

    case "reviewadd":
        reviewadd($pageid, $reviewtitle, $reviewcomments, $reviewscore);
        break;

    case "reviewdelete":
        reviewdelete($reviewid, $ok);
        break;

    default:
        listsubjects();
        break;
}

?>